diff --git a/compiler/stranal/WwLib.lhs b/compiler/stranal/WwLib.lhs
index c0c3f6c..454befc 100644
--- a/compiler/stranal/WwLib.lhs
+++ b/compiler/stranal/WwLib.lhs
@@ -4,34 +4,28 @@
 \section[WwLib]{A library for the ``worker\/wrapper'' back-end to the strictness analyser}
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module WwLib ( mkWwBodies, mkWWstr, mkWorkerArgs, deepSplitProductType_maybe ) where
 
 #include "HsVersions.h"
 
 import CoreSyn
-import CoreUtils	( exprType, mkCast )
-import Id		( Id, idType, mkSysLocal, idDemandInfo, setIdDemandInfo,
-			  isOneShotLambda, setOneShotLambda, setIdUnfolding,
+import CoreUtils        ( exprType, mkCast )
+import Id               ( Id, idType, mkSysLocal, idDemandInfo, setIdDemandInfo,
+                          isOneShotLambda, setOneShotLambda, setIdUnfolding,
                           setIdInfo
-			)
-import IdInfo		( vanillaIdInfo )
+                        )
+import IdInfo           ( vanillaIdInfo )
 import DataCon
 import Demand        
-import MkCore		( mkRuntimeErrorApp, aBSENT_ERROR_ID )
-import MkId		( realWorldPrimId, voidArgId )
-import TysPrim		( realWorldStatePrimTy )
-import TysWiredIn	( tupleCon )
+import MkCore           ( mkRuntimeErrorApp, aBSENT_ERROR_ID )
+import MkId             ( realWorldPrimId, voidArgId )
+import TysPrim          ( realWorldStatePrimTy )
+import TysWiredIn       ( tupleCon )
 import Type
 import Coercion hiding  ( substTy, substTyVarBndr )
-import BasicTypes	( TupleSort(..) )
-import Literal		( absentLiteralOf )
+import BasicTypes       ( TupleSort(..) )
+import Literal          ( absentLiteralOf )
 import TyCon
 import UniqSupply
 import Unique
@@ -44,9 +38,9 @@ import FastString
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[mkWrapperAndWorker]{@mkWrapperAndWorker@}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 Here's an example.  The original function is:
@@ -55,9 +49,9 @@ Here's an example.  The original function is:
 g :: forall a . Int -> [a] -> a
 
 g = \/\ a -> \ x ys ->
-	case x of
-	  0 -> head ys
-	  _ -> head (tail ys)
+        case x of
+          0 -> head ys
+          _ -> head (tail ys)
 \end{verbatim}
 
 From this, we want to produce:
@@ -66,20 +60,20 @@ From this, we want to produce:
 g :: forall a . Int -> [a] -> a
 
 g = \/\ a -> \ x ys ->
-	case x of
-	  I# x# -> $wg a x# ys
-	    -- call the worker; don't forget the type args!
+        case x of
+          I# x# -> $wg a x# ys
+            -- call the worker; don't forget the type args!
 
 -- worker
 $wg :: forall a . Int# -> [a] -> a
 
 $wg = \/\ a -> \ x# ys ->
-	let
-	    x = I# x#
-	in
-	    case x of		    -- note: body of g moved intact
-	      0 -> head ys
-	      _ -> head (tail ys)
+        let
+            x = I# x#
+        in
+            case x of               -- note: body of g moved intact
+              0 -> head ys
+              _ -> head (tail ys)
 \end{verbatim}
 
 Something we have to be careful about:  Here's an example:
@@ -88,7 +82,7 @@ Something we have to be careful about:  Here's an example:
 -- "f" strictness: U(P)U(P)
 f (I# a) (I# b) = a +# b
 
-g = f	-- "g" strictness same as "f"
+g = f   -- "g" strictness same as "f"
 \end{verbatim}
 
 \tr{f} will get a worker all nice and friendly-like; that's good.
@@ -103,45 +97,45 @@ the unusable strictness-info into the interfaces.
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{The worker wrapper core}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 @mkWwBodies@ is called when doing the worker\/wrapper split inside a module.
 
 \begin{code}
 mkWwBodies :: DynFlags
-       -> Type				-- Type of original function
-	   -> [Demand]				-- Strictness of original function
-	   -> DmdResult				-- Info about function result
-	   -> [Bool]				-- One-shot-ness of the function
-	   -> UniqSM ([Demand],			-- Demands for worker (value) args
-		      Id -> CoreExpr,		-- Wrapper body, lacking only the worker Id
-		      CoreExpr -> CoreExpr)	-- Worker body, lacking the original function rhs
-
--- wrap_fn_args E	= \x y -> E
--- work_fn_args E	= E x y
-
--- wrap_fn_str E 	= case x of { (a,b) -> 
---			  case a of { (a1,a2) ->
---			  E a1 a2 b y }}
--- work_fn_str E	= \a2 a2 b y ->
---			  let a = (a1,a2) in
---			  let x = (a,b) in
---			  E
+       -> Type                          -- Type of original function
+           -> [Demand]                          -- Strictness of original function
+           -> DmdResult                         -- Info about function result
+           -> [Bool]                            -- One-shot-ness of the function
+           -> UniqSM ([Demand],                 -- Demands for worker (value) args
+                      Id -> CoreExpr,           -- Wrapper body, lacking only the worker Id
+                      CoreExpr -> CoreExpr)     -- Worker body, lacking the original function rhs
+
+-- wrap_fn_args E       = \x y -> E
+-- work_fn_args E       = E x y
+
+-- wrap_fn_str E        = case x of { (a,b) -> 
+--                        case a of { (a1,a2) ->
+--                        E a1 a2 b y }}
+-- work_fn_str E        = \a2 a2 b y ->
+--                        let a = (a1,a2) in
+--                        let x = (a,b) in
+--                        E
 
 mkWwBodies dflags fun_ty demands res_info one_shots
-  = do	{ let arg_info = demands `zip` (one_shots ++ repeat False)
+  = do  { let arg_info = demands `zip` (one_shots ++ repeat False)
               all_one_shots = all snd arg_info
-	; (wrap_args, wrap_fn_args, work_fn_args, res_ty) <- mkWWargs emptyTvSubst fun_ty arg_info
-	; (work_args, wrap_fn_str,  work_fn_str) <- mkWWstr dflags wrap_args
+        ; (wrap_args, wrap_fn_args, work_fn_args, res_ty) <- mkWWargs emptyTvSubst fun_ty arg_info
+        ; (work_args, wrap_fn_str,  work_fn_str) <- mkWWstr dflags wrap_args
 
         -- Do CPR w/w.  See Note [Always do CPR w/w]
-	; (wrap_fn_cpr, work_fn_cpr,  cpr_res_ty) <- mkWWcpr res_ty res_info
+        ; (wrap_fn_cpr, work_fn_cpr,  cpr_res_ty) <- mkWWcpr res_ty res_info
 
-	; let (work_lam_args, work_call_args) = mkWorkerArgs dflags work_args all_one_shots cpr_res_ty
-	; return ([idDemandInfo v | v <- work_call_args, isId v],
+        ; let (work_lam_args, work_call_args) = mkWorkerArgs dflags work_args all_one_shots cpr_res_ty
+        ; return ([idDemandInfo v | v <- work_call_args, isId v],
                   wrap_fn_args . wrap_fn_cpr . wrap_fn_str . applyToVars work_call_args . Var,
                   mkLams work_lam_args. work_fn_str . work_fn_cpr . work_fn_args) }
         -- We use an INLINE unconditionally, even if the wrapper turns out to be
@@ -167,32 +161,32 @@ is Trac #5920.
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Making wrapper args}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 During worker-wrapper stuff we may end up with an unlifted thing
 which we want to let-bind without losing laziness.  So we
 add a void argument.  E.g.
 
-	f = /\a -> \x y z -> E::Int#	-- E does not mention x,y,z
+        f = /\a -> \x y z -> E::Int#    -- E does not mention x,y,z
 ==>
-	fw = /\ a -> \void -> E
-	f  = /\ a -> \x y z -> fw realworld
+        fw = /\ a -> \void -> E
+        f  = /\ a -> \x y z -> fw realworld
 
 We use the state-token type which generates no code.
 
 \begin{code}
 mkWorkerArgs :: DynFlags -> [Var]
              -> Bool    -- Whether all arguments are one-shot
-	     -> Type	-- Type of body
-	     -> ([Var],	-- Lambda bound args
-		 [Var])	-- Args at call site
+             -> Type    -- Type of body
+             -> ([Var], -- Lambda bound args
+                 [Var]) -- Args at call site
 mkWorkerArgs dflags args all_one_shot res_ty
     | any isId args || not needsAValueLambda
     = (args, args)
-    | otherwise	
+    | otherwise 
     = (args ++ [newArg], args ++ [realWorldPrimId])
     where
       needsAValueLambda =
@@ -239,32 +233,32 @@ $j_s1l1 =
         GHC.Types.True ->  ... }
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Coercion stuff}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 We really want to "look through" coerces.
 Reason: I've seen this situation:
 
-	let f = coerce T (\s -> E)
-	in \x -> case x of
-	   	    p -> coerce T' f
-		    q -> \s -> E2
-	   	    r -> coerce T' f
+        let f = coerce T (\s -> E)
+        in \x -> case x of
+                    p -> coerce T' f
+                    q -> \s -> E2
+                    r -> coerce T' f
 
 If only we w/w'd f, we'd get
-	let f = coerce T (\s -> fw s)
-	    fw = \s -> E
-	in ...
+        let f = coerce T (\s -> fw s)
+            fw = \s -> E
+        in ...
 
 Now we'll inline f to get
 
-	let fw = \s -> E
-	in \x -> case x of
-	   	    p -> fw
-		    q -> \s -> E2
-	   	    r -> fw
+        let fw = \s -> E
+        in \x -> case x of
+                    p -> fw
+                    q -> \s -> E2
+                    r -> fw
 
 Now we'll see that fw has arity 1, and will arity expand
 the \x to get what we want.
@@ -275,67 +269,67 @@ the \x to get what we want.
 -- It chomps bites off foralls, arrows, newtypes
 -- and keeps repeating that until it's satisfied the supplied arity
 
-mkWWargs :: TvSubst		-- Freshening substitution to apply to the type
-				--   See Note [Freshen type variables]
-	 -> Type		-- The type of the function
-	 -> [(Demand,Bool)]	-- Demands and one-shot info for value arguments
-	 -> UniqSM  ([Var],		-- Wrapper args
-		     CoreExpr -> CoreExpr,	-- Wrapper fn
-		     CoreExpr -> CoreExpr,	-- Worker fn
-		     Type)			-- Type of wrapper body
+mkWWargs :: TvSubst             -- Freshening substitution to apply to the type
+                                --   See Note [Freshen type variables]
+         -> Type                -- The type of the function
+         -> [(Demand,Bool)]     -- Demands and one-shot info for value arguments
+         -> UniqSM  ([Var],             -- Wrapper args
+                     CoreExpr -> CoreExpr,      -- Wrapper fn
+                     CoreExpr -> CoreExpr,      -- Worker fn
+                     Type)                      -- Type of wrapper body
 
 mkWWargs subst fun_ty arg_info
   | Just (rep_ty, co) <- splitNewTypeRepCo_maybe fun_ty
-   	-- The newtype case is for when the function has
-	-- a recursive newtype after the arrow (rare)
-	-- We check for arity >= 0 to avoid looping in the case
-	-- of a function whose type is, in effect, infinite
-	-- [Arity is driven by looking at the term, not just the type.]
-	--
-	-- It's also important when we have a function returning (say) a pair
-	-- wrapped in a recursive newtype, at least if CPR analysis can look 
-	-- through such newtypes, which it probably can since they are 
-	-- simply coerces.
-	--
-	-- Note (Sept 08): This case applies even if demands is empty.
-	--		   I'm not quite sure why; perhaps it makes it
-	--		   easier for CPR
+        -- The newtype case is for when the function has
+        -- a recursive newtype after the arrow (rare)
+        -- We check for arity >= 0 to avoid looping in the case
+        -- of a function whose type is, in effect, infinite
+        -- [Arity is driven by looking at the term, not just the type.]
+        --
+        -- It's also important when we have a function returning (say) a pair
+        -- wrapped in a recursive newtype, at least if CPR analysis can look 
+        -- through such newtypes, which it probably can since they are 
+        -- simply coerces.
+        --
+        -- Note (Sept 08): This case applies even if demands is empty.
+        --                 I'm not quite sure why; perhaps it makes it
+        --                 easier for CPR
   = do { (wrap_args, wrap_fn_args, work_fn_args, res_ty)
-	    <-  mkWWargs subst rep_ty arg_info
- 	; return (wrap_args,
-	     	  \e -> Cast (wrap_fn_args e) (mkSymCo co),
-     		  \e -> work_fn_args (Cast e co),
-     		  res_ty) } 
+            <-  mkWWargs subst rep_ty arg_info
+        ; return (wrap_args,
+                  \e -> Cast (wrap_fn_args e) (mkSymCo co),
+                  \e -> work_fn_args (Cast e co),
+                  res_ty) } 
 
   | null arg_info
   = return ([], id, id, substTy subst fun_ty)
 
   | Just (tv, fun_ty') <- splitForAllTy_maybe fun_ty
-  = do 	{ let (subst', tv') = substTyVarBndr subst tv
-		-- This substTyVarBndr clones the type variable when necy
-		-- See Note [Freshen type variables]
-  	; (wrap_args, wrap_fn_args, work_fn_args, res_ty)
-	     <- mkWWargs subst' fun_ty' arg_info
-	; return (tv' : wrap_args,
-        	  Lam tv' . wrap_fn_args,
-        	  work_fn_args . (`App` Type (mkTyVarTy tv')),
-        	  res_ty) }
+  = do  { let (subst', tv') = substTyVarBndr subst tv
+                -- This substTyVarBndr clones the type variable when necy
+                -- See Note [Freshen type variables]
+        ; (wrap_args, wrap_fn_args, work_fn_args, res_ty)
+             <- mkWWargs subst' fun_ty' arg_info
+        ; return (tv' : wrap_args,
+                  Lam tv' . wrap_fn_args,
+                  work_fn_args . (`App` Type (mkTyVarTy tv')),
+                  res_ty) }
 
   | ((dmd,one_shot):arg_info') <- arg_info
   , Just (arg_ty, fun_ty') <- splitFunTy_maybe fun_ty
-  = do	{ uniq <- getUniqueM
-	; let arg_ty' = substTy subst arg_ty
-	      id = mk_wrap_arg uniq arg_ty' dmd one_shot
-	; (wrap_args, wrap_fn_args, work_fn_args, res_ty)
-	      <- mkWWargs subst fun_ty' arg_info'
-	; return (id : wrap_args,
-	          Lam id . wrap_fn_args,
-        	  work_fn_args . (`App` varToCoreExpr id),
-        	  res_ty) }
+  = do  { uniq <- getUniqueM
+        ; let arg_ty' = substTy subst arg_ty
+              id = mk_wrap_arg uniq arg_ty' dmd one_shot
+        ; (wrap_args, wrap_fn_args, work_fn_args, res_ty)
+              <- mkWWargs subst fun_ty' arg_info'
+        ; return (id : wrap_args,
+                  Lam id . wrap_fn_args,
+                  work_fn_args . (`App` varToCoreExpr id),
+                  res_ty) }
 
   | otherwise
-  = WARN( True, ppr fun_ty )			-- Should not happen: if there is a demand
-    return ([], id, id, substTy subst fun_ty) 	-- then there should be a function arrow
+  = WARN( True, ppr fun_ty )                    -- Should not happen: if there is a demand
+    return ([], id, id, substTy subst fun_ty)   -- then there should be a function arrow
 
 applyToVars :: [Var] -> CoreExpr -> CoreExpr
 applyToVars vars fn = mkVarApps fn vars
@@ -358,25 +352,25 @@ within a type (e.g. forall a. a -> forall a. a->a).  But type
 variables *are* mentioned in <blah>, so we must substitute.
 
 That's why we carry the TvSubst through mkWWargs
-	
+        
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Strictness stuff}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 mkWWstr :: DynFlags
-        -> [Var]				-- Wrapper args; have their demand info on them
-						--  *Includes type variables*
-        -> UniqSM ([Var],			-- Worker args
-		   CoreExpr -> CoreExpr,	-- Wrapper body, lacking the worker call
-						-- and without its lambdas 
-						-- This fn adds the unboxing
-				
-		   CoreExpr -> CoreExpr)	-- Worker body, lacking the original body of the function,
-						-- and lacking its lambdas.
-						-- This fn does the reboxing
+        -> [Var]                                -- Wrapper args; have their demand info on them
+                                                --  *Includes type variables*
+        -> UniqSM ([Var],                       -- Worker args
+                   CoreExpr -> CoreExpr,        -- Wrapper body, lacking the worker call
+                                                -- and without its lambdas 
+                                                -- This fn adds the unboxing
+                                
+                   CoreExpr -> CoreExpr)        -- Worker body, lacking the original body of the function,
+                                                -- and lacking its lambdas.
+                                                -- This fn does the reboxing
 mkWWstr _ []
   = return ([], nop_fn, nop_fn)
 
@@ -403,10 +397,10 @@ will be unpacked, but
 will not, because the pieces aren't used. This is quite important otherwise
 we end up unpacking massive tuples passed to the bottoming function. Example:
 
- 	f :: ((Int,Int) -> String) -> (Int,Int) -> a
- 	f g pr = error (g pr)
+        f :: ((Int,Int) -> String) -> (Int,Int) -> a
+        f g pr = error (g pr)
 
- 	main = print (f fst (1, error "no"))
+        main = print (f fst (1, error "no"))
 
 Does 'main' print "error 1" or "error no"?  We don't really want 'f'
 to unbox its second argument.  This actually happened in GHC's onwn
@@ -418,9 +412,9 @@ as-yet-un-filled-in pkgState files.
 ----------------------
 -- mkWWstr_one wrap_arg = (work_args, wrap_fn, work_fn)
 --   *  wrap_fn assumes wrap_arg is in scope,
---	  brings into scope work_args (via cases)
+--        brings into scope work_args (via cases)
 --   * work_fn assumes work_args are in scope, a
---	  brings into scope wrap_arg (via lets)
+--        brings into scope wrap_arg (via lets)
 mkWWstr_one :: DynFlags -> Var -> UniqSM ([Var], CoreExpr -> CoreExpr, CoreExpr -> CoreExpr)
 mkWWstr_one dflags arg
   | isTyVar arg
@@ -436,21 +430,21 @@ mkWWstr_one dflags arg
   | isSeqDmd dmd  -- `seq` demand; evaluate in wrapper in the hope
                   -- of dropping seqs in the worker
   = let arg_w_unf = arg `setIdUnfolding` evaldUnfolding
-	  -- Tell the worker arg that it's sure to be evaluated
+          -- Tell the worker arg that it's sure to be evaluated
           -- so that internal seqs can be dropped
     in return ([arg_w_unf], mk_seq_case arg, nop_fn)
-	  	-- Pass the arg, anyway, even if it is in theory discarded
-		-- Consider
-		--	f x y = x `seq` y
-		-- x gets a (Eval (Poly Abs)) demand, but if we fail to pass it to the worker
-		-- we ABSOLUTELY MUST record that x is evaluated in the wrapper.
-		-- Something like:
-		--	f x y = x `seq` fw y
-		--	fw y = let x{Evald} = error "oops" in (x `seq` y)
-		-- If we don't pin on the "Evald" flag, the seq doesn't disappear, and
-		-- we end up evaluating the absent thunk.
-		-- But the Evald flag is pretty weird, and I worry that it might disappear
-		-- during simplification, so for now I've just nuked this whole case
+                -- Pass the arg, anyway, even if it is in theory discarded
+                -- Consider
+                --      f x y = x `seq` y
+                -- x gets a (Eval (Poly Abs)) demand, but if we fail to pass it to the worker
+                -- we ABSOLUTELY MUST record that x is evaluated in the wrapper.
+                -- Something like:
+                --      f x y = x `seq` fw y
+                --      fw y = let x{Evald} = error "oops" in (x `seq` y)
+                -- If we don't pin on the "Evald" flag, the seq doesn't disappear, and
+                -- we end up evaluating the absent thunk.
+                -- But the Evald flag is pretty weird, and I worry that it might disappear
+                -- during simplification, so for now I've just nuked this whole case
 
   | isStrictDmd dmd
   , Just cs <- splitProdDmd_maybe dmd
@@ -458,28 +452,28 @@ mkWWstr_one dflags arg
   , Just (data_con, inst_tys, inst_con_arg_tys, co) 
              <- deepSplitProductType_maybe (idType arg)
   =  do { (uniq1:uniqs) <- getUniquesM
-	; let   unpk_args      = zipWith mk_ww_local uniqs inst_con_arg_tys
-	        unpk_args_w_ds = zipWithEqual "mkWWstr" set_worker_arg_info unpk_args cs
-	        unbox_fn       = mkUnpackCase (Var arg `mkCast` co) uniq1
+        ; let   unpk_args      = zipWith mk_ww_local uniqs inst_con_arg_tys
+                unpk_args_w_ds = zipWithEqual "mkWWstr" set_worker_arg_info unpk_args cs
+                unbox_fn       = mkUnpackCase (Var arg `mkCast` co) uniq1
                                               data_con unpk_args
-	        rebox_fn       = Let (NonRec arg con_app) 
-	        con_app        = mkConApp2 data_con inst_tys unpk_args `mkCast` mkSymCo co
-	 ; (worker_args, wrap_fn, work_fn) <- mkWWstr dflags unpk_args_w_ds
-	 ; return (worker_args, unbox_fn . wrap_fn, work_fn . rebox_fn) }
-	  		   -- Don't pass the arg, rebox instead
-			
-  | otherwise	-- Other cases
+                rebox_fn       = Let (NonRec arg con_app) 
+                con_app        = mkConApp2 data_con inst_tys unpk_args `mkCast` mkSymCo co
+         ; (worker_args, wrap_fn, work_fn) <- mkWWstr dflags unpk_args_w_ds
+         ; return (worker_args, unbox_fn . wrap_fn, work_fn . rebox_fn) }
+                           -- Don't pass the arg, rebox instead
+                        
+  | otherwise   -- Other cases
   = return ([arg], nop_fn, nop_fn)
 
   where
     dmd = idDemandInfo arg
-	-- If the wrapper argument is a one-shot lambda, then
-	-- so should (all) the corresponding worker arguments be
-	-- This bites when we do w/w on a case join point
+        -- If the wrapper argument is a one-shot lambda, then
+        -- so should (all) the corresponding worker arguments be
+        -- This bites when we do w/w on a case join point
     set_worker_arg_info worker_arg demand = set_one_shot (setIdDemandInfo worker_arg demand)
 
     set_one_shot | isOneShotLambda arg = setOneShotLambda
-		 | otherwise	       = \x -> x
+                 | otherwise           = \x -> x
 
 ----------------------
 nop_fn :: CoreExpr -> CoreExpr
@@ -510,9 +504,9 @@ deepSplitCprType_maybe _ _ = Nothing
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{CPR stuff}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 
@@ -529,8 +523,8 @@ left-to-right traversal of the result structure.
 mkWWcpr :: Type                              -- function body type
         -> DmdResult                         -- CPR analysis results
         -> UniqSM (CoreExpr -> CoreExpr,             -- New wrapper 
-                   CoreExpr -> CoreExpr,	     -- New worker
-		   Type)			-- Type of worker's body 
+                   CoreExpr -> CoreExpr,             -- New worker
+                   Type)                        -- Type of worker's body 
 
 mkWWcpr body_ty res
   = case returnsCPR_maybe res of
@@ -547,31 +541,31 @@ mkWWcpr_help :: (DataCon, [Type], [Type], Coercion)
 mkWWcpr_help (data_con, inst_tys, arg_tys, co)
   | [arg_ty1] <- arg_tys
   , isUnLiftedType arg_ty1
-	-- Special case when there is a single result of unlifted type
-	--
-	-- Wrapper:	case (..call worker..) of x -> C x
-	-- Worker:	case (   ..body..    ) of C x -> x
+        -- Special case when there is a single result of unlifted type
+        --
+        -- Wrapper:     case (..call worker..) of x -> C x
+        -- Worker:      case (   ..body..    ) of C x -> x
   = do { (work_uniq : arg_uniq : _) <- getUniquesM
        ; let arg       = mk_ww_local arg_uniq  arg_ty1
-	     con_app   = mkConApp2 data_con inst_tys [arg] `mkCast` co
+             con_app   = mkConApp2 data_con inst_tys [arg] `mkCast` co
 
        ; return ( \ wkr_call -> Case wkr_call arg (exprType con_app) [(DEFAULT, [], con_app)]
                 , \ body     -> mkUnpackCase body work_uniq data_con [arg] (Var arg)
                 , arg_ty1 ) }
 
-  | otherwise 	-- The general case
-	-- Wrapper: case (..call worker..) of (# a, b #) -> C a b
-	-- Worker:  case (   ...body...  ) of C a b -> (# a, b #)     
+  | otherwise   -- The general case
+        -- Wrapper: case (..call worker..) of (# a, b #) -> C a b
+        -- Worker:  case (   ...body...  ) of C a b -> (# a, b #)     
   = do { (work_uniq : uniqs) <- getUniquesM
        ; let (wrap_wild : args) = zipWith mk_ww_local uniqs (ubx_tup_ty : arg_tys)
-	     ubx_tup_con  = tupleCon UnboxedTuple (length arg_tys)
-	     ubx_tup_ty	  = exprType ubx_tup_app
-	     ubx_tup_app  = mkConApp2 ubx_tup_con arg_tys args
-             con_app	  = mkConApp2 data_con inst_tys args `mkCast` co
+             ubx_tup_con  = tupleCon UnboxedTuple (length arg_tys)
+             ubx_tup_ty   = exprType ubx_tup_app
+             ubx_tup_app  = mkConApp2 ubx_tup_con arg_tys args
+             con_app      = mkConApp2 data_con inst_tys args `mkCast` co
 
        ; return ( \ wkr_call -> Case wkr_call wrap_wild (exprType con_app)  [(DataAlt ubx_tup_con, args, con_app)]
-		, \ body     -> mkUnpackCase body work_uniq data_con args ubx_tup_app
-		, ubx_tup_ty ) }
+                , \ body     -> mkUnpackCase body work_uniq data_con args ubx_tup_app
+                , ubx_tup_ty ) }
 
 mkUnpackCase ::  CoreExpr -> Unique -> DataCon -> [Id] -> CoreExpr -> CoreExpr
 -- (mkUnpackCase e bndr Con args body)
@@ -591,12 +585,12 @@ mkUnpackCase scrut uniq boxing_con unpk_args body
 Note [Profiling and unpacking]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 If the original function looked like
-	f = \ x -> _scc_ "foo" E
+        f = \ x -> _scc_ "foo" E
 
 then we want the CPR'd worker to look like
-	\ x -> _scc_ "foo" (case E of I# x -> x)
+        \ x -> _scc_ "foo" (case E of I# x -> x)
 and definitely not
-	\ x -> case (_scc_ "foo" E) of I# x -> x)
+        \ x -> case (_scc_ "foo" E) of I# x -> x)
 
 This transform doesn't move work or allocation
 from one cost centre to another.
@@ -608,9 +602,9 @@ part of the function (post transformation) anyway.
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Utilities}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 Note [Absent errors]
@@ -661,10 +655,10 @@ sanitiseCaseBndr :: Id -> Id
 -- a case binder, so it's convenient to re-use it for that purpose.
 -- But we *must* throw away all its IdInfo.  In particular, the argument
 -- will have demand info on it, and that demand info may be incorrect for
--- the case binder.  e.g.  	case ww_arg of ww_arg { I# x -> ... }
+-- the case binder.  e.g.       case ww_arg of ww_arg { I# x -> ... }
 -- Quite likely ww_arg isn't used in '...'.  The case may get discarded
 -- if the case binder says "I'm demanded".  This happened in a situation 
--- like		(x+y) `seq` ....
+-- like         (x+y) `seq` ....
 sanitiseCaseBndr id = id `setIdInfo` vanillaIdInfo
 
 mk_ww_local :: Unique -> Type -> Id
